
// This file is generated by src/Tools/generateTemplates/templateClassPyExport.py out of the .XML file
// Every change you make here gets lost in the next full rebuild!
// This File is normally built as an include in PolyHLRToShapePyImp.cpp! It's not intended to be in a project!

#include <boost/filesystem/path.hpp>
#include <boost/filesystem/operations.hpp>
#include <boost/filesystem/exception.hpp>
#include <Base/PyObjectBase.h>
#include <Base/Console.h>
#include <Base/Exception.h>
#include <CXX/Objects.hxx>

#if defined(__clang__)
# pragma clang diagnostic push
# pragma clang diagnostic ignored "-Wdeprecated-declarations"
#endif

using Base::streq;
using namespace Part;

#if defined(__GNUC__)
#pragma GCC diagnostic push
// Ignore -Wmissing-field-initializers (GCC only):
// - C++20 guarantees omitted fields are zero-initialized.
// - Python C API changes fields across versions.
// - Clang does not warn; GCC does unnecessarily.
// See https://gcc.gnu.org/bugzilla/show_bug.cgi?id=96868
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif // __GNUC__
/// Type structure of PolyHLRToShapePy
PyTypeObject PolyHLRToShapePy::Type = {
    .ob_base = PyVarObject_HEAD_INIT(&PyType_Type,0)
    .tp_name = "Part.PolyHLRToShapePy",
    .tp_basicsize = sizeof(PolyHLRToShapePy),
    .tp_itemsize = 0,
    /* methods */
    .tp_dealloc = PyDestructor,
    .tp_repr = __repr,
    .tp_getattro = __getattro,
    .tp_setattro = __setattro,
    /* --- Flags to define presence of optional/expanded features */
    .tp_flags = Py_TPFLAGS_BASETYPE|Py_TPFLAGS_DEFAULT,
    .tp_doc = "PolyHLRToShape(algo: HLRBRep_PolyAlgo) -> HLRBRep_PolyHLRToShape\n"
    "\n"
    "A framework for filtering the computation results of an HLRBRep_PolyAlgo\n"
    "algorithm by extraction.  From the results calculated by the algorithm on a\n"
    "shape, a filter returns the type of edge you want to identify.  You can choose\n"
    "any of the following types of output:\n"
    "- visible sharp edges\n"
    "- hidden sharp edges\n"
    "- visible smooth edges\n"
    "- hidden smooth edges\n"
    "- visible sewn edges\n"
    "- hidden sewn edges\n"
    "- visible outline edges\n"
    "- hidden outline edges\n"
    "- visible isoparameters and\n"
    "- hidden isoparameters.\n"
    "\n"
    "Sharp edges present a C0 continuity (non G1). Smooth edges present a G1\n"
    "continuity (non G2). Sewn edges present a C2 continuity. The result is composed\n"
    "of 2D edges in the projection plane of the view which the algorithm has worked\n"
    "with. These 2D edges are not included in the data structure of the visualized\n"
    "shape. In order to obtain a complete image, you must combine the shapes given\n"
    "by each of the chosen filters. The construction of the shape does not call a\n"
    "new computation of the algorithm, but only reads its internal results.",
    .tp_methods = Part::PolyHLRToShapePy::Methods,
    .tp_getset = Part::PolyHLRToShapePy::GetterSetter,
    .tp_base = &Base::PyObjectBase::Type,
    .tp_init = __PyInit,
    .tp_new = Part::PolyHLRToShapePy::PyMake
};
#if defined(__GNUC__)
#pragma GCC diagnostic pop
#endif // __GNUC__

/// Methods structure of PolyHLRToShapePy
PyMethodDef PolyHLRToShapePy::Methods[] = {
    {"update",
        reinterpret_cast<PyCFunction>( staticCallback_update ),
        METH_VARARGS,
        "update(algo: HLRBRep_PolyAlgo)"
    },
    {"show",
        reinterpret_cast<PyCFunction>( staticCallback_show ),
        METH_VARARGS,
        "show()"
    },
    {"hide",
        reinterpret_cast<PyCFunction>( staticCallback_hide ),
        METH_VARARGS,
        "hide()"
    },
    {"vCompound",
        reinterpret_cast<PyCFunction>( staticCallback_vCompound ),
        METH_VARARGS,
        "vCompound(Shape=None) -> TopoShape\n"
        "\n"
        "Sets the extraction filter for visible sharp edges for either shape Shape or\n"
        "for all added shapes (Shape=None)."
    },
    {"Rg1LineVCompound",
        reinterpret_cast<PyCFunction>( staticCallback_Rg1LineVCompound ),
        METH_VARARGS,
        "Rg1LineVCompound(Shape=None) -> TopoShape\n"
        "\n"
        "Sets the extraction filter for visible smooth edges for either shape Shape or\n"
        "for all added shapes (Shape=None)."
    },
    {"RgNLineVCompound",
        reinterpret_cast<PyCFunction>( staticCallback_RgNLineVCompound ),
        METH_VARARGS,
        "RgNLineVCompound(Shape=None) -> TopoShape\n"
        "\n"
        "Sets the extraction filter for visible sewn edges for either shape Shape or for\n"
        "all added shapes (Shape=None)."
    },
    {"outLineVCompound",
        reinterpret_cast<PyCFunction>( staticCallback_outLineVCompound ),
        METH_VARARGS,
        "outLineVCompound(Shape=None) -> TopoShape\n"
        "\n"
        "Sets the extraction filter for visible outline edges for either shape Shape or\n"
        "for all added shapes (Shape=None)."
    },
    {"hCompound",
        reinterpret_cast<PyCFunction>( staticCallback_hCompound ),
        METH_VARARGS,
        "hCompound(Shape=None) -> TopoShape\n"
        "\n"
        "Sets the extraction filter for hidden sharp edges for either shape Shape or for\n"
        "all added shapes (Shape=None)."
    },
    {"Rg1LineHCompound",
        reinterpret_cast<PyCFunction>( staticCallback_Rg1LineHCompound ),
        METH_VARARGS,
        "Rg1LineHCompound(Shape=None) -> TopoShape\n"
        "\n"
        "Sets the extraction filter for hidden smooth edges for either shape Shape or\n"
        "for all added shapes (Shape=None)."
    },
    {"RgNLineHCompound",
        reinterpret_cast<PyCFunction>( staticCallback_RgNLineHCompound ),
        METH_VARARGS,
        "RgNLineHCompound(Shape=None) -> TopoShape\n"
        "\n"
        "Sets the extraction filter for hidden sewn edges for either shape Shape or for\n"
        "all added shapes (Shape=None)."
    },
    {"outLineHCompound",
        reinterpret_cast<PyCFunction>( staticCallback_outLineHCompound ),
        METH_VARARGS,
        "outLineHCompound(Shape=None) -> TopoShape\n"
        "\n"
        "Sets the extraction filter for hidden outline edges for either shape Shape or\n"
        "for all added shapes (Shape=None)."
    },
    {nullptr, nullptr, 0, nullptr}		/* Sentinel */
};



/// Attribute structure of PolyHLRToShapePy
PyGetSetDef PolyHLRToShapePy::GetterSetter[] = {
    {nullptr, nullptr, nullptr, nullptr, nullptr}		/* Sentinel */
};

// update() callback and implementer
// PyObject*  PolyHLRToShapePy::update(PyObject *args){};
// has to be implemented in PolyHLRToShapePyImp.cpp
PyObject * PolyHLRToShapePy::staticCallback_update (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'update' of 'Part.HLRBRep_PolyHLRToShape' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<PolyHLRToShapePy*>(self)->update(args);
        if (ret != nullptr)
            static_cast<PolyHLRToShapePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// show() callback and implementer
// PyObject*  PolyHLRToShapePy::show(PyObject *args){};
// has to be implemented in PolyHLRToShapePyImp.cpp
PyObject * PolyHLRToShapePy::staticCallback_show (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'show' of 'Part.HLRBRep_PolyHLRToShape' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<PolyHLRToShapePy*>(self)->show(args);
        if (ret != nullptr)
            static_cast<PolyHLRToShapePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// hide() callback and implementer
// PyObject*  PolyHLRToShapePy::hide(PyObject *args){};
// has to be implemented in PolyHLRToShapePyImp.cpp
PyObject * PolyHLRToShapePy::staticCallback_hide (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'hide' of 'Part.HLRBRep_PolyHLRToShape' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<PolyHLRToShapePy*>(self)->hide(args);
        if (ret != nullptr)
            static_cast<PolyHLRToShapePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// vCompound() callback and implementer
// PyObject*  PolyHLRToShapePy::vCompound(PyObject *args){};
// has to be implemented in PolyHLRToShapePyImp.cpp
PyObject * PolyHLRToShapePy::staticCallback_vCompound (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'vCompound' of 'Part.HLRBRep_PolyHLRToShape' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<PolyHLRToShapePy*>(self)->vCompound(args);
        if (ret != nullptr)
            static_cast<PolyHLRToShapePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// Rg1LineVCompound() callback and implementer
// PyObject*  PolyHLRToShapePy::Rg1LineVCompound(PyObject *args){};
// has to be implemented in PolyHLRToShapePyImp.cpp
PyObject * PolyHLRToShapePy::staticCallback_Rg1LineVCompound (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'Rg1LineVCompound' of 'Part.HLRBRep_PolyHLRToShape' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<PolyHLRToShapePy*>(self)->Rg1LineVCompound(args);
        if (ret != nullptr)
            static_cast<PolyHLRToShapePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// RgNLineVCompound() callback and implementer
// PyObject*  PolyHLRToShapePy::RgNLineVCompound(PyObject *args){};
// has to be implemented in PolyHLRToShapePyImp.cpp
PyObject * PolyHLRToShapePy::staticCallback_RgNLineVCompound (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'RgNLineVCompound' of 'Part.HLRBRep_PolyHLRToShape' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<PolyHLRToShapePy*>(self)->RgNLineVCompound(args);
        if (ret != nullptr)
            static_cast<PolyHLRToShapePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// outLineVCompound() callback and implementer
// PyObject*  PolyHLRToShapePy::outLineVCompound(PyObject *args){};
// has to be implemented in PolyHLRToShapePyImp.cpp
PyObject * PolyHLRToShapePy::staticCallback_outLineVCompound (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'outLineVCompound' of 'Part.HLRBRep_PolyHLRToShape' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<PolyHLRToShapePy*>(self)->outLineVCompound(args);
        if (ret != nullptr)
            static_cast<PolyHLRToShapePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// hCompound() callback and implementer
// PyObject*  PolyHLRToShapePy::hCompound(PyObject *args){};
// has to be implemented in PolyHLRToShapePyImp.cpp
PyObject * PolyHLRToShapePy::staticCallback_hCompound (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'hCompound' of 'Part.HLRBRep_PolyHLRToShape' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<PolyHLRToShapePy*>(self)->hCompound(args);
        if (ret != nullptr)
            static_cast<PolyHLRToShapePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// Rg1LineHCompound() callback and implementer
// PyObject*  PolyHLRToShapePy::Rg1LineHCompound(PyObject *args){};
// has to be implemented in PolyHLRToShapePyImp.cpp
PyObject * PolyHLRToShapePy::staticCallback_Rg1LineHCompound (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'Rg1LineHCompound' of 'Part.HLRBRep_PolyHLRToShape' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<PolyHLRToShapePy*>(self)->Rg1LineHCompound(args);
        if (ret != nullptr)
            static_cast<PolyHLRToShapePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// RgNLineHCompound() callback and implementer
// PyObject*  PolyHLRToShapePy::RgNLineHCompound(PyObject *args){};
// has to be implemented in PolyHLRToShapePyImp.cpp
PyObject * PolyHLRToShapePy::staticCallback_RgNLineHCompound (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'RgNLineHCompound' of 'Part.HLRBRep_PolyHLRToShape' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<PolyHLRToShapePy*>(self)->RgNLineHCompound(args);
        if (ret != nullptr)
            static_cast<PolyHLRToShapePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}

// outLineHCompound() callback and implementer
// PyObject*  PolyHLRToShapePy::outLineHCompound(PyObject *args){};
// has to be implemented in PolyHLRToShapePyImp.cpp
PyObject * PolyHLRToShapePy::staticCallback_outLineHCompound (PyObject *self, PyObject *args)
{
    // make sure that not a null pointer is passed
    if (!self) {
        PyErr_SetString(PyExc_TypeError, "descriptor 'outLineHCompound' of 'Part.HLRBRep_PolyHLRToShape' object needs an argument");
        return nullptr;
    }

    // test if twin object isn't already deleted
    if (!static_cast<PyObjectBase*>(self)->isValid()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is already deleted most likely through closing a document. This reference is no longer valid!");
        return nullptr;
    }

    // test if object is set Const
    if (static_cast<PyObjectBase*>(self)->isConst()) {
        PyErr_SetString(PyExc_ReferenceError, "This object is immutable, you can not set any attribute or call a non const method");
        return nullptr;
    }

    try { // catches all exceptions coming up from c++ and generate a python exception
        PyObject* ret = static_cast<PolyHLRToShapePy*>(self)->outLineHCompound(args);
        if (ret != nullptr)
            static_cast<PolyHLRToShapePy*>(self)->startNotify();
        return ret;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return nullptr;
    }
#endif
}




//--------------------------------------------------------------------------
// Constructor
//--------------------------------------------------------------------------
PolyHLRToShapePy::PolyHLRToShapePy(HLRBRep_PolyHLRToShape *pcObject, PyTypeObject *T)
    : PyObjectBase(static_cast<PyObjectBase::PointerType>(pcObject), T)
{
}


//--------------------------------------------------------------------------
// destructor
//--------------------------------------------------------------------------
PolyHLRToShapePy::~PolyHLRToShapePy()                                // Everything handled in parent
{
    // delete the handled object when the PyObject dies
    PolyHLRToShapePy::PointerType ptr = static_cast<PolyHLRToShapePy::PointerType>(_pcTwinPointer);
    delete ptr;
}

//--------------------------------------------------------------------------
// PolyHLRToShapePy representation
//--------------------------------------------------------------------------
PyObject *PolyHLRToShapePy::_repr()
{
    return Py_BuildValue("s", representation().c_str());
}

//--------------------------------------------------------------------------
// PolyHLRToShapePy Attributes
//--------------------------------------------------------------------------
PyObject *PolyHLRToShapePy::_getattr(const char *attr)			// __getattr__ function: note only need to handle new state
{
    try {
        // getter method for special Attributes (e.g. dynamic ones)
        PyObject *r = getCustomAttributes(attr);
        if(r) return r;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return nullptr;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return nullptr;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return nullptr;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError,"Unknown C++ exception");
        return nullptr;
    }
#endif

    PyMethodDef *ml = Methods;
    for (; ml->ml_name != nullptr; ml++) {
        if (attr[0] == ml->ml_name[0] &&
            strcmp(attr+1, ml->ml_name+1) == 0)
            return PyCFunction_New(ml, this);
    }

    PyErr_Clear();
    return PyObjectBase::_getattr(attr);
}

int PolyHLRToShapePy::_setattr(const char *attr, PyObject *value) // __setattr__ function: note only need to handle new state
{
    try {
        // setter for special Attributes (e.g. dynamic ones)
        int r = setCustomAttributes(attr, value);
        // r = 1: handled
        // r = -1: error
        // r = 0: ignore
        if (r == 1)
            return 0;
        else if (r == -1)
            return -1;
    } // Please sync the following catch implementation with PY_CATCH
    catch(const Base::Exception& e)
    {
        e.setPyException();
        return -1;
    }
    catch(const std::exception& e)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, e.what());
        return -1;
    }
    catch(const Py::Exception&)
    {
        // The exception text is already set
        return -1;
    }
#ifndef DONT_CATCH_CXX_EXCEPTIONS
    catch(...)
    {
        PyErr_SetString(Base::PyExc_FC_GeneralError, "Unknown C++ exception");
        return -1;
    }
#endif

    return PyObjectBase::_setattr(attr, value);
}

HLRBRep_PolyHLRToShape *PolyHLRToShapePy::getHLRBRep_PolyHLRToShapePtr() const
{
    return static_cast<HLRBRep_PolyHLRToShape *>(_pcTwinPointer);
}

#if defined(__clang__)
# pragma clang diagnostic pop
#endif

#if 0
/* From here on come the methods you have to implement, but NOT in this module. Implement in PolyHLRToShapePyImp.cpp! This prototypes
 * are just for convenience when you add a new method.
 */

PyObject *PolyHLRToShapePy::PyMake(PyTypeObject* /*type*/, PyObject* /*args*/, PyObject* /*kwds*/)
{
    // create a new instance of PolyHLRToShapePy and the Twin object
    return new PolyHLRToShapePy(new HLRBRep_PolyHLRToShape);
}

// constructor method
int PolyHLRToShapePy::PyInit(PyObject* /*args*/, PyObject* /*kwd*/)
{
    return 0;
}


// returns a string which represents the object e.g. when printed in python
std::string PolyHLRToShapePy::representation() const
{
    return {"<HLRBRep_PolyHLRToShape object>"};
}

PyObject* PolyHLRToShapePy::update(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* PolyHLRToShapePy::show(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* PolyHLRToShapePy::hide(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* PolyHLRToShapePy::vCompound(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* PolyHLRToShapePy::Rg1LineVCompound(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* PolyHLRToShapePy::RgNLineVCompound(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* PolyHLRToShapePy::outLineVCompound(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* PolyHLRToShapePy::hCompound(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* PolyHLRToShapePy::Rg1LineHCompound(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* PolyHLRToShapePy::RgNLineHCompound(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}

PyObject* PolyHLRToShapePy::outLineHCompound(PyObject *args)
{
    PyErr_SetString(PyExc_NotImplementedError, "Not yet implemented");
    return nullptr;
}



PyObject *PolyHLRToShapePy::getCustomAttributes(const char* /*attr*/) const
{
    return nullptr;
}

int PolyHLRToShapePy::setCustomAttributes(const char* /*attr*/, PyObject* /*obj*/)
{
    return 0;
}


#endif



